﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Security.Permissions;
using System.Collections;
using AM = HeuristicLab.Services.Authentication.AdminMethods;
using System.Collections.Generic;

namespace HeuristicLab.Services.DemoService {
  // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
  public class Service : IService {
    [PrincipalPermission(SecurityAction.Demand, Role = "Everyone")]
    public string GetData(int value) {
      return string.Format("You entered: {0}", value);
    }

    public CompositeType GetDataUsingDataContract(CompositeType composite) {
      if (composite == null) {
        throw new ArgumentNullException("composite");
      }
      if (composite.BoolValue) {
        composite.StringValue += "Suffix";
      }
      return composite;
    }

    public bool CreateClient(string name, string descr, string groupID, string resGroup){
      Hashtable sht = new Hashtable();
      sht[AM.eResource.ResourceID] = ""; //notwendig ""
      sht[AM.eResource.Name]= name;
      sht[AM.eResource.Description] = descr;
      sht[AM.eResource.ResourceType] = resGroup;
      sht[AM.eResource.ResourceIDGroup] = groupID;
      return new AM.ClientAdmin().Create(sht); 
    }

    public bool CreateGroup(string name, string descr) {
      Hashtable sht = new Hashtable();
      sht[AM.eResource.Name] = name;
      sht[AM.eResource.Description] = descr;
      return new AM.GroupAdmin().Create(sht);
    }

    public string GetGroupID(string name) {
      string gIDStr = "";
      HashSet<Hashtable> rht = new HashSet<Hashtable>();
      Hashtable sht = new Hashtable();
      sht[AM.eResource.Name] = "g1";
      rht = new AM.GroupAdmin().Get(sht);
      foreach (Hashtable ht in rht) {
        gIDStr = ht[AM.eResource.ResourceID].ToString();
      }
      return gIDStr;
    }
  }
}
